/*
 *  Sample C -- header file for symbol table 
 */

#include <stdio.h>

typedef struct symtab {
  char * name;                    /* name pointer */
  int kind;                       /* symbol type */
  int blockLevel;                 /* static block depth */
  union {
    int num;                      /* parameter number */
    struct symtab * link;         /* parameter link */
  } S;
  int offset;                     /* symbolic definitions */
  struct symtab * next;           /* next entry */
} WORD;


typedef WORD * WORDPTR;

#define NOTSET (-1)               /* no count yet set */

/*
 *  kinds values
 */

#define UDEC  0                   /* not declared */
#define FUNC  1                   /* fuction */
#define UFUNC 2                   /* undefined function */
#define VAR   3                   /* declared variable */
#define PARAM 4                   /* undeclared parameter */


/* 
 * typed functions, symbol table module
 */


WORDPTR linkParam();              /* chain parameters */
WORDPTR find();                   /* locate symbol by name */
WORDPTR makeParam();              /* declare parameter */
WORDPTR makeVar();                /* define variable */
WORDPTR makeFunc();               /* define function */
void blockPush();
void blockPop();
void checkVar( WORDPTR symbol);
void checkFunc( WORDPTR symbol);
void checkParam( WORDPTR symbol, int count);
